﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadTreeViewCollapse
{
    public partial class Form1 : Form
    {
        RadTreeView tree = new RadTreeView(); 

        public Form1()
        {
            InitializeComponent();
            tree.Parent = this;
            tree.Dock = DockStyle.Fill;

            RadTreeNode lastNode = null;   
            for (int i = 0; i < 20; i++)
            {
                lastNode = tree.Nodes.Add("Node " + i);
                for (int j = 0; j < 10; j++)
                {
                    lastNode = lastNode.Nodes.Add("Node " + i + " " + j);
                    lastNode.Nodes.Add("Node " + i + " " + j);
                    lastNode.Nodes.Add("Node " + i + " " + j);
                    for (int k = 0; k < 5; k++)
                    {
                        lastNode = lastNode.Nodes.Add("Node " + i + " " + j + " " + k);
                        lastNode.Nodes.Add("Node " + i + " " + j + " " + k);
                        lastNode.Nodes.Add("Node " + i + " " + j + " " + k);
                    }
                }
            }

            this.tree.CheckBoxes = true;
            this.tree.NodeCheckedChanged += tree_NodeCheckedChanged;
        }

        void tree_NodeCheckedChanged(object sender, TreeNodeCheckedEventArgs e)
        {
            List<RadTreeNode> nodes = this.GetChildNodes(e.Node);
            if (e.Node.CheckState == Telerik.WinControls.Enumerations.ToggleState.Off)
            {
                foreach (RadTreeNode node in nodes)
                {
                    if (node.Nodes.Count > 0)
                    {
                        node.Collapse();
                    }
                }

                e.Node.Collapse();
            }
            else if (e.Node.CheckState == Telerik.WinControls.Enumerations.ToggleState.On)
            {
                foreach (RadTreeNode node in nodes)
                {
                    if (node.Nodes.Count > 0)
                    {
                        node.Expand();
                    }
                }

                e.Node.Expand();
            }

        }

        private List<RadTreeNode> GetChildNodes(RadTreeNode parent)
        {
            List<RadTreeNode> returnlist = new List<RadTreeNode>();
            this.GetChildNodesCore(returnlist, parent);

            return returnlist;
        }

        private void GetChildNodesCore(List<RadTreeNode> list, RadTreeNode parent)
        {
            foreach (var child in parent.Nodes)
            {
                list.Add(child);
                GetChildNodesCore(list, child);
            }
        }
    }
}
